/*-------------------------------------------------------------------------------------------------
 - #%L                                                                                            -
 - protocol-core                                                                                  -
 - %%                                                                                             -
 - Copyright (C) 2016 - 2018 République et Canton de Genève                                       -
 - %%                                                                                             -
 - This program is free software: you can redistribute it and/or modify                           -
 - it under the terms of the GNU Affero General Public License as published by                    -
 - the Free Software Foundation, either version 3 of the License, or                              -
 - (at your option) any later version.                                                            -
 -                                                                                                -
 - This program is distributed in the hope that it will be useful,                                -
 - but WITHOUT ANY WARRANTY; without even the implied warranty of                                 -
 - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                                   -
 - GNU General Public License for more details.                                                   -
 -                                                                                                -
 - You should have received a copy of the GNU Affero General Public License                       -
 - along with this program. If not, see <http://www.gnu.org/licenses/>.                           -
 - #L%                                                                                            -
 -------------------------------------------------------------------------------------------------*/

package ch.ge.ve.protocol.core.algorithm;

import static ch.ge.ve.protocol.core.support.ByteArrayUtils.markByteArray;

import ch.ge.ve.protocol.core.exception.IncoherentListsRuntimeException;
import ch.ge.ve.protocol.core.model.SecretVoterData;
import ch.ge.ve.protocol.core.model.VotingCard;
import ch.ge.ve.protocol.core.support.ByteArrayUtils;
import ch.ge.ve.protocol.core.support.Conversion;
import ch.ge.ve.protocol.model.ElectionSet;
import ch.ge.ve.protocol.model.PublicParameters;
import ch.ge.ve.protocol.model.Voter;
import com.google.common.base.Preconditions;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 * Algorithms related to the preparation of code sheets
 */
public class VotingCardPreparationAlgorithms {
  private final Conversion conversion = new Conversion();
  private final PublicParameters publicParameters;
  private final int              s;

  public VotingCardPreparationAlgorithms(PublicParameters publicParameters) {
    this.publicParameters = publicParameters;
    s = publicParameters.getS();
  }

  /**
   * Algorithm 7.13: GetVotingCards
   * <p>Computes the voting card (containing all codes) for every voter</p>
   *
   * @param electionSet  the electionSet definition, including bold_v, bold_w, bold_c, bold_n, bold_k and bold_upper_e
   * @param bold_upper_d the secret voter data generated by each authority for each voter (codeSheetData.get(j) =
   *                     bold_d_j : the list of the voters' secret data for authority j)
   *
   * @return all the relevant information combined for printing on the code sheets
   */
  public List<VotingCard> getVotingCards(ElectionSet<?> electionSet, List<List<SecretVoterData>> bold_upper_d) {
    Preconditions.checkArgument(bold_upper_d.size() == publicParameters.getS(),
                                String.format("|D| [%d] != s [%d]", bold_upper_d.size(), publicParameters.getS()));
    // Each printing authority is responsible for a subset of the voters.
    List<Voter> voters = bold_upper_d.stream().findFirst().orElse(new ArrayList<>()).stream()
                                     .map(SecretVoterData::getVoter).collect(Collectors.toList());
    Preconditions.checkArgument(bold_upper_d.stream().allMatch(
        secretVoterDatas -> secretVoterDatas.size() == voters.size()),
                                "Each authority should have submitted one code sheet per voter");

    List<VotingCard> votingCards = new ArrayList<>();
    for (Voter v_i : voters) {
      // for each authority, get the secret data pertaining to voter i
      List<SecretVoterData> secretVoterDataList = bold_upper_d.stream().map(
          list -> list.stream()
                      .filter(secretVoterData -> secretVoterData.getVoter().equals(v_i)).findFirst()
                      .orElseThrow(() -> new IncoherentListsRuntimeException("no match for voter " + v_i.getVoterId())))
                                                              .collect(Collectors.toList());

      List<Integer> bold_k_i = compute_bold_k_i(electionSet, v_i);
      String upper_x = compute_upper_x(secretVoterDataList);
      String upper_y = compute_upper_y(secretVoterDataList);
      String upper_fc = compute_upper_fc(secretVoterDataList);
      List<String> bold_rc = compute_bold_rc(electionSet, secretVoterDataList);

      votingCards.add(getVotingCard(v_i, bold_k_i, upper_x, upper_y, upper_fc, bold_rc));
    }
    return votingCards;
  }

  /**
   * upper_x = ToByteArray( \sum{j=1,s}(x_{ij}), L_x)
   *
   * @param secretVoterDataList the secret voter data generated by each of the authorities for this voter
   *
   * @return the byte array conversion of the sum of individual <tt>x_ij</tt>s
   */
  private String compute_upper_x(List<SecretVoterData> secretVoterDataList) {
    BigInteger sum_x_ij = IntStream.range(0, s).mapToObj(secretVoterDataList::get)
                                   .map(SecretVoterData::getX)
                                   .reduce(BigInteger::add).orElse(BigInteger.ZERO);
    Preconditions.checkArgument(sum_x_ij.compareTo(publicParameters.getQ_hat_x()) < 0,
                                "the sum of the x_ij's must be lesser than q_hat_x");
    return conversion.toString(sum_x_ij, publicParameters.getL_x(), publicParameters.getUpper_a_x());
  }

  /**
   * upper_y = ToByteArray( \sum{j=1,s}(y_{ij}), L_y)
   *
   * @param secretVoterDataList the secret voter data generated by each of the authorities for this voter
   *
   * @return the byte array conversion of the sum of individual <tt>y_ij</tt>s
   */
  private String compute_upper_y(List<SecretVoterData> secretVoterDataList) {
    BigInteger sum_y_ij = IntStream.range(0, s).mapToObj(secretVoterDataList::get)
                                   .map(SecretVoterData::getY)
                                   .reduce(BigInteger::add).orElse(BigInteger.ZERO);
    Preconditions.checkArgument(sum_y_ij.compareTo(publicParameters.getQ_hat_y()) < 0,
                                "the sum of the y_ij's must be lesser than q_hat_y");
    //noinspection SuspiciousNameCombination
    return conversion.toString(sum_y_ij, publicParameters.getL_y(), publicParameters.getUpper_a_y());
  }

  /**
   * upper_fc = \xor{j=1,s}(F_{ij})
   *
   * @param secretVoterDataList the secret voter data generated by each of the authorities for this voter
   *
   * @return the result of xoring the individual <tt>F_ij</tt>s
   */
  private String compute_upper_fc(List<SecretVoterData> secretVoterDataList) {
    List<Character> upper_a_f = publicParameters.getUpper_a_f();
    return IntStream.range(0, s).mapToObj(secretVoterDataList::get)
                    .map(SecretVoterData::getF)
                    .reduce(ByteArrayUtils::xor)
                    .map(b -> conversion.toString(b, upper_a_f))
                    .orElse("");
  }

  /**
   * 1. RC_ik = \xor{j=1,s}(RC_{ijk})
   * 2. mark byte array
   * 3. convert to string
   *
   * @param secretVoterDataList the secret voter data generated by each of the authorities for this voter
   *
   * @return for each k, the result of xoring the individual <tt>RC_ijk</tt>s
   */
  private List<String> compute_bold_rc(ElectionSet<?> electionSet, List<SecretVoterData> secretVoterDataList) {
    List<Character> upper_a_r = publicParameters.getUpper_a_r();
    return IntStream.range(0, electionSet.getCandidates().size()).mapToObj(
        k -> IntStream.range(0, s).mapToObj(secretVoterDataList::get)
                      .map(secretVoterData -> secretVoterData.getRc()[k])
                      .reduce(ByteArrayUtils::xor)
                      // 1.
                      .map(upper_r_ik -> markByteArray(upper_r_ik, k, publicParameters.getN_max()))
                      // 2.
                      .map(b -> conversion.toString(b, upper_a_r))
                      // 3.
                      .orElse("")
    ).collect(Collectors.toList());
  }

  /**
   * k_i = (e_{i,1} * k_1, ..., e_{i,t} * kt)
   *
   * @param electionSet the electionSet definition, including v, c, n, k and E
   * @param v_i         the individual voter
   *
   * @return the vector of allowed number of selections per election for the voter
   */
  private List<Integer> compute_bold_k_i(ElectionSet<?> electionSet, Voter v_i) {
    return electionSet.getElections().stream()
                      .map(e -> electionSet.isEligible(v_i, e) ? e.getNumberOfSelections() : 0)
                      .collect(Collectors.toList());
  }

  /**
   * Algorithm 7.14: GetVotingCard
   *
   * @param v_i         the voter for whom this card is valid, containing the voter index i, the voter
   *                    description upper_v and the counting circle w
   * @param bold_k      the number of selections the voter can make for each election
   * @param upper_x     the element to be used for identification
   * @param upper_y     the element to be used for confirmation
   * @param upper_fc    the element to be used as finalization code
   * @param bold_rc     the vector of the elements to be used for the verification codes
   *
   * @return the elements needed for the voter's code sheet
   */
  private VotingCard getVotingCard(Voter v_i, List<Integer> bold_k, String upper_x,
                                   String upper_y, String upper_fc, List<String> bold_rc) {
    return new VotingCard(v_i, bold_k, upper_x, upper_y, upper_fc, bold_rc);
  }
}
